
#include "baseenv.h"

#ifdef THINKC5
#include <AppleTalk.h>
#else
#ifdef WERKS
#include <AppleTalk.h>
#else
#include <nAppleTalk.h>
#endif
#endif

/* ******************************************************************* */

#define REQBUFFSIZE 6

typedef struct _afStr
{	char *nbpBuff;	/* buffer for nbp data */
	char connect;	/* TRUE if connected */
	char inUse;		/* true if this entry is in use */
	int socketN;	/* my socket # */
	char reqBuff[REQBUFFSIZE];	/* buffer for async read GetRequest */
	int rbSize;		/* size of reqBuff */
	Ptr requestP;	/* dereferenced handle from async GetRequest */
	AddrBlock address;	/* address of other side of stream */
	Handle wBuffer;	/* write buffer */
	long wPos;		/* current position in write buffer (writing here) */
	Handle rBuffer;	/* read buffer */
	long rFill;		/* read buffer fill */
	long rPos;		/* read position */
	char haveConn;
	char haveRead;
	int readFails; /* # of times a read hasn't connected */
} AStream;

/* don't want CHUNKSIZE larger than appletalk datagram size! (568) */
#define CHUNKSIZE 512L

/* maximum number of allowed read failures */
#define MAXREADFAIL 3

/* maximum write buffer */
#define MAXWBUFF (CHUNKSIZE*16)
/* maximum read buffer */
#define MAXRBUFF (CHUNKSIZE*16)
/* note that we want both read & write buffers to be > 8000, which is the size of
	the read used in TUTORread_doc.  If buffers are smaller, then TUTORread_doc
	may think the "file" has ended when it hasn't */

/* maximum amount of time (in ticks) that write will wait */
#define WRITEWAIT 1800

/* ******************************************************************* */

struct PTPConInf { /* information for Program-to-Program connection */
	int inUse; /* TRUE if this slot in use */
	int id; /* id (index) of this stream */
	int connect; /* TRUE if connection established */
	int openport; /* TRUE if port opened */
	int server; /* TRUE if server */
	int connectBroken; /* TRUE if connection broken by other side */
	long timeConnect; /* time connect established */
	long portRefNum; /* port reference number */
	long sessRefNum; /* session reference number */
	PPCParamBlockRec informParam; /* inform data  */
	PPCParamBlockRec startParam; /* start data  */
	PPCParamBlockRec readParam; /* read data  */
	PPCParamBlockRec writeParam; /* write data */
	PPCPortRec portInf; /* description of port */
	LocationNameRec nameInf;  /* description of location */
	PPCPortRec serverPortInf; /* description of server port */
	LocationNameRec serverNameInf; /* description of server location */
	int readBuffSize; /* size of read buffer for this port */
	int writeBuffSize; /* size of write buffer for this port */
	char FAR *readBuffP; /* pointer to read buffer */
	char FAR *writeBuffP; /* pointer to write buffer */
	int expectComplete; /* 1 = expect inform complete */
	                    /* 2 = expect accept complete */
	                    /* 3 = expect start complete */
	                    /* 4 = expect read/write complete */
	int readIssued; /* number read requests issued */
	int readCompleted; /* number read requests completed */
	int readInP; /* current input position in read buffer */
	int readOutP; /* current output position in read buffer */
	int readCrit; /* TRUE if process in critical code */
	int writeIssued; /* number write requests issued */
	int writeCompleted; /* number write requests completed */
	int writeInP; /* current input position in write buffer */
	int ungetC; /* unget character */
	struct PTPConInf *nextStream; /* pointer to next connection info */
}; /* PTPConInf */

#define cmpl_inform 1
#define cmpl_accept 2
#define cmpl_start 3
#define cmpl_rw 4


